VERSION 4.00
Begin VB.Form frmBF 
   Caption         =   "frmBF"
   ClientHeight    =   1680
   ClientLeft      =   2145
   ClientTop       =   1830
   ClientWidth     =   4560
   ClipControls    =   0   'False
   DrawStyle       =   5  'Transparent
   FillColor       =   &H8000000F&
   FillStyle       =   0  'Solid
   Height          =   2370
   Left            =   2085
   LinkTopic       =   "Form1"
   ScaleHeight     =   112
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   304
   Top             =   1200
   Width           =   4680
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   200
      Left            =   270
      Top             =   90
   End
   Begin VB.Menu mnuStartStop 
      Caption         =   "Start/Stop"
   End
   Begin VB.Menu mnuFaster 
      Caption         =   "Faster"
   End
   Begin VB.Menu mnuSlower 
      Caption         =   "Slower"
   End
End
Attribute VB_Name = "frmBF"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
'=============================================
'Demonstration of the LoadImage API transparent capabilites.
'    Tom Esh 76467.1255@compuserve.com
'=============================================

'Notes:
'Windows 95 & 98 - no problem.
'Windows NT - unknown - but apparently some LR_ flags not supported.

'LoadImage - un2 settings:
'    LR_LOADFROMFILE : Loads the image from the file specified by the lpszName parameter. If this flag is not specified, lpszName is the name of the resource.
'    LR_LOADMAP3DCOLORS  : Searches the color table for the image and replaces the following shades of gray with the corresponding 3D color:
'    Color   Replaced with
'    Dk Gray, RGB(128,128,128)   COLOR_3DSHADOW
'    Gray, RGB(192,192,192)  COLOR_3DFACE
'    Lt Gray, RGB(223,223,223)   COLOR_3DLIGHT
'    LR_LOADTRANSPARENT  : Retrieves the color value of the first pixel in the image and replaces the corresponding entry in the color table with the default window color (COLOR_WINDOW). All pixels in the image that use that entry become the default window color. This value applies only to images that have corresponding color tables. If fuLoad includes both the LR_LOADTRANSPARENT and LR_LOADMAP3DCOLORS values, LRLOADTRANSPARENT takes precedence. However, the color table entry is replaced with COLOR_3DFACE rather than COLOR_WINDOW.


Option Explicit

Private Const LR_LOADFROMFILE = &H10
Private Const LR_LOADMAP3DCOLORS = &H1000
Private Const LR_LOADTRANSPARENT = &H20
Private Const IMAGE_BITMAP = 0
Private Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Dim hBmp(0 To 1) As Long 'source bitmap handles
Dim hTdc(0 To 1) As Long 'source DCs for BitBlt

Private Function IsIDE() As Boolean
    'Returns True if running in IDE mode, False if running from compiled EXE.
    On Error GoTo ErrIDE
    Debug.Print 1 / 0 'causes error, but Debug statements are ignored in runtime mode.
    Exit Function
ErrIDE:
    IsIDE = True
End Function

Private Sub Form_Load()
    Dim i As Integer
    
    'Although VB can find resources in a RES module for its own LoadRes..
    'functions in IDE mode, API functions don't receive the same special treatment.
    'Therefore, in IDE mode the images must be loaded directly from their bmp files.
    'In EXE mode, either method will work, but loading them from a RES eliminates
    'having to distribute separate bmp files.
    
    If IsIDE Then 'must load from file (NT 4 or later)
        hBmp(0) = LoadImage(0&, App.Path & "\bfly1.bmp", IMAGE_BITMAP, 77&, 77&, LR_LOADMAP3DCOLORS Or LR_LOADTRANSPARENT Or LR_LOADFROMFILE)
        hBmp(1) = LoadImage(0&, App.Path & "\bfly2.bmp", IMAGE_BITMAP, 77&, 77&, LR_LOADMAP3DCOLORS Or LR_LOADTRANSPARENT Or LR_LOADFROMFILE)
    Else 'EXE mode - can load from RES
        hBmp(0) = LoadImage(App.hInstance, "#2", IMAGE_BITMAP, 77&, 77&, LR_LOADMAP3DCOLORS Or LR_LOADTRANSPARENT)
        hBmp(1) = LoadImage(App.hInstance, "#3", IMAGE_BITMAP, 77&, 77&, LR_LOADMAP3DCOLORS Or LR_LOADTRANSPARENT)
    End If
    
    For i = 0 To 1
        hTdc(i) = CreateCompatibleDC(Me.hdc) 'BitBlt needs source DCs
        Call SelectObject(hTdc(i), hBmp(i)) 'select bitmaps into DCs
    Next
    
    Me.Show
    DoEvents
    
    'display static images...
    Call BitBlt(Me.hdc, 20&, 20&, 77&, 77&, hTdc(0), 0&, 0&, vbSrcCopy)
    Call BitBlt(Me.hdc, 150&, 20&, 77&, 77&, hTdc(1), 0&, 0&, vbSrcCopy)
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim i As Integer
    
    Timer1.Enabled = False
    
    'Important - free resources...
    For i = 0 To 1
        Call DeleteDC(hTdc(i))
        Call DeleteObject(hBmp(i))
    Next
End Sub

Private Sub mnuFaster_Click()
    Dim i As Integer
    i = Timer1.Interval
    If i > 50 Then Timer1.Interval = i - 50
End Sub

Private Sub mnuSlower_Click()
    Dim i As Integer
    i = Timer1.Interval
    If i < 500 Then Timer1.Interval = i + 50
End Sub

Private Sub mnuStartStop_Click()
    Timer1.Enabled = Not Timer1.Enabled
End Sub

Private Sub Timer1_Timer()
    Static Toggle As Boolean
    Static LastX As Long
    Dim NewX As Long
    
    Toggle = Not Toggle
    
    If LastX < ScaleWidth Then
        NewX = LastX + 25
    Else
        NewX = -77
    End If
    
    'erase previous image...
    'Me.Line (LastX, 20)-(LastX + 77, 97), vbButtonFace, BF 'Ok, but...
    Call Rectangle(Me.hdc, LastX, 20&, LastX + 77&, 97&) '... a little faster
        
    'BitBlt new image...
    Call BitBlt(Me.hdc, NewX, 20&, 77&, 77&, hTdc(Abs(Toggle)), 0&, 0&, vbSrcCopy)
    
    LastX = NewX
End Sub
